package ast;

import types.Type;

public class Atrib extends Node implements Stat{
	public Id lval;
	public Exp rval;
	
	public Atrib(Id lval, Exp rval, int line, int col) {
		super(line, col);
		this.lval = lval;
		this.rval = rval;
	}
	
	public String label() {
		return "=";
	}
	
	public void run(Environment<Object> env) {
		env.update(lval.name, rval.eval(env));
	}

	@Override
	public void tcStat(Environment<Type> tenv) {
		Type tlval = tenv.lookup(lval.name);
		Type trval = rval.tcExp(tenv);
		tlval.checkEq(trval, this);
	}
}
